// Copyright (C) 2015,2016 Tomoyuki Fujimori <moyu@dromozoa.com>
//
// This file is part of dromozoa-unix.
//
// dromozoa-unix is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// dromozoa-unix is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with dromozoa-unix.  If not, see <http://www.gnu.org/licenses/>.

extern "C" {
#include <lua.h>
}

#include <sys/time.h>

#include "error.hpp"
#include "function.hpp"
#include "set_field.hpp"

namespace dromozoa {
  namespace {
    int impl_gettimeofday(lua_State* L) {
      struct timeval tv = {};
      if (gettimeofday(&tv, 0) != -1) {
        lua_newtable(L);
        set_field(L, "tv_sec", tv.tv_sec);
        set_field(L, "tv_usec", tv.tv_usec);
        return 1;
      } else {
        return push_error(L);
      }
    }
  }

  void initialize_gettimeofday(lua_State* L) {
    function<impl_gettimeofday>::set_field(L, "gettimeofday");
  }
}
